diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/he/he-phy.cc ns-3.45/src/wifi/model/he/he-phy.cc
--- ns-3.44/src/wifi/model/he/he-phy.cc	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/he/he-phy.cc	2025-06-01 20:34:45.617702200 -0700
@@ -216,8 +216,10 @@
         NS_ASSERT(txVector.GetModulationClass() >= WIFI_MOD_CLASS_HE);
         return HePpdu::GetSigBFieldSize(
             txVector.GetChannelWidth(),
+            txVector.GetModulationClass(),
             txVector.GetRuAllocation(
                 m_wifiPhy ? m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(MHz_u{20}) : 0),
+            txVector.GetCenter26ToneRuIndication(),
             txVector.IsSigBCompression(),
             txVector.IsSigBCompression() ? txVector.GetHeMuUserInfoMap().size() : 0);
     }
@@ -872,7 +874,7 @@
     NS_LOG_FUNCTION(this << *psdu << txVector << snr);
     if (!txVector.IsUlMu())
     {
-        m_state->SwitchFromRxEndError();
+        m_state->SwitchFromRxEndError(txVector);
     }
 }
 
@@ -905,7 +907,7 @@
             }
             else
             {
-                m_state->SwitchFromRxEndError();
+                m_state->SwitchFromRxEndError(ppdu->GetTxVector());
             }
             NotifyInterferenceRxEndAndClear(true); // reset WifiPhy
             m_rxHeTbPpdus = 0;
@@ -966,7 +968,7 @@
 {
     if (txVector.IsMu())
     {
-        return {HeRu::GetBandwidth(txVector.GetRu(staId).GetRuType()),
+        return {WifiRu::GetBandwidth(WifiRu::GetRuType(txVector.GetRu(staId))),
                 GetRuBandForRx(txVector, staId)};
     }
     else
@@ -979,23 +981,27 @@
 HePhy::GetRuBandForTx(const WifiTxVector& txVector, uint16_t staId) const
 {
     NS_ASSERT(txVector.IsMu());
-    HeRu::RuSpec ru = txVector.GetRu(staId);
+    auto ru = txVector.GetRu(staId);
     const auto channelWidth = txVector.GetChannelWidth();
     NS_ASSERT(channelWidth <= m_wifiPhy->GetChannelWidth());
-    HeRu::SubcarrierGroup group = HeRu::GetSubcarrierGroup(
+    const auto mc = txVector.GetModulationClass();
+    const auto group = WifiRu::GetSubcarrierGroup(
         channelWidth,
-        ru.GetRuType(),
-        ru.GetPhyIndex(channelWidth,
-                       m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(MHz_u{20})));
+        WifiRu::GetRuType(ru),
+        WifiRu::GetPhyIndex(ru,
+                            channelWidth,
+                            m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(MHz_u{20})),
+        mc);
     // for a TX spectrum, the guard bandwidth is a function of the transmission channel width
     // and the spectrum width equals the transmission channel width (hence bandIndex equals 0)
-    const auto indices = ConvertHeRuSubcarriers(channelWidth,
-                                                GetGuardBandwidth(channelWidth),
-                                                m_wifiPhy->GetOperatingChannel().GetFrequencies(),
-                                                m_wifiPhy->GetChannelWidth(),
-                                                m_wifiPhy->GetSubcarrierSpacing(),
-                                                {group.front().first, group.back().second},
-                                                0);
+    const auto indices = ConvertRuSubcarriers({channelWidth,
+                                               GetGuardBandwidth(channelWidth),
+                                               m_wifiPhy->GetOperatingChannel().GetFrequencies(),
+                                               m_wifiPhy->GetChannelWidth(),
+                                               m_wifiPhy->GetSubcarrierSpacing(),
+                                               mc,
+                                               {group.front().first, group.back().second},
+                                               0});
     WifiSpectrumBandInfo ruBandForTx{};
     for (const auto& indicesPerSegment : indices)
     {
@@ -1010,24 +1016,28 @@
 HePhy::GetRuBandForRx(const WifiTxVector& txVector, uint16_t staId) const
 {
     NS_ASSERT(txVector.IsMu());
-    HeRu::RuSpec ru = txVector.GetRu(staId);
+    auto ru = txVector.GetRu(staId);
     const auto channelWidth = txVector.GetChannelWidth();
     NS_ASSERT(channelWidth <= m_wifiPhy->GetChannelWidth());
-    HeRu::SubcarrierGroup group = HeRu::GetSubcarrierGroup(
+    const auto mc = txVector.GetModulationClass();
+    const auto group = WifiRu::GetSubcarrierGroup(
         channelWidth,
-        ru.GetRuType(),
-        ru.GetPhyIndex(channelWidth,
-                       m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(MHz_u{20})));
+        WifiRu::GetRuType(ru),
+        WifiRu::GetPhyIndex(ru,
+                            channelWidth,
+                            m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(MHz_u{20})),
+        mc);
     // for an RX spectrum, the guard bandwidth is a function of the operating channel width
     // and the spectrum width equals the operating channel width
-    const auto indices = ConvertHeRuSubcarriers(
-        channelWidth,
-        GetGuardBandwidth(m_wifiPhy->GetChannelWidth()),
-        m_wifiPhy->GetOperatingChannel().GetFrequencies(),
-        m_wifiPhy->GetChannelWidth(),
-        m_wifiPhy->GetSubcarrierSpacing(),
-        {group.front().first, group.back().second},
-        m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(channelWidth));
+    const auto indices = ConvertRuSubcarriers(
+        {channelWidth,
+         GetGuardBandwidth(m_wifiPhy->GetChannelWidth()),
+         m_wifiPhy->GetOperatingChannel().GetFrequencies(),
+         m_wifiPhy->GetChannelWidth(),
+         m_wifiPhy->GetSubcarrierSpacing(),
+         mc,
+         {group.front().first, group.back().second},
+         m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(channelWidth)});
     WifiSpectrumBandInfo ruBandForRx{};
     for (const auto& indicesPerSegment : indices)
     {
@@ -1038,53 +1048,17 @@
     return ruBandForRx;
 }
 
-WifiSpectrumBandInfo
-HePhy::GetNonOfdmaBand(const WifiTxVector& txVector, uint16_t staId) const
-{
-    NS_ASSERT(txVector.IsUlMu() && (txVector.GetModulationClass() >= WIFI_MOD_CLASS_HE));
-    const auto channelWidth = txVector.GetChannelWidth();
-    NS_ASSERT(channelWidth <= m_wifiPhy->GetChannelWidth());
-
-    HeRu::RuSpec ru = txVector.GetRu(staId);
-    const auto nonOfdmaWidth = GetNonOfdmaWidth(ru);
-
-    // Find the RU that encompasses the non-OFDMA part of the HE TB PPDU for the STA-ID
-    HeRu::RuSpec nonOfdmaRu =
-        HeRu::FindOverlappingRu(channelWidth, ru, HeRu::GetRuType(nonOfdmaWidth));
-
-    HeRu::SubcarrierGroup groupPreamble = HeRu::GetSubcarrierGroup(
-        channelWidth,
-        nonOfdmaRu.GetRuType(),
-        nonOfdmaRu.GetPhyIndex(channelWidth,
-                               m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(MHz_u{20})));
-    const auto indices = ConvertHeRuSubcarriers(
-        channelWidth,
-        GetGuardBandwidth(m_wifiPhy->GetChannelWidth()),
-        m_wifiPhy->GetOperatingChannel().GetFrequencies(),
-        m_wifiPhy->GetChannelWidth(),
-        m_wifiPhy->GetSubcarrierSpacing(),
-        {groupPreamble.front().first, groupPreamble.back().second},
-        m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(channelWidth));
-    WifiSpectrumBandInfo nonOfdmaBand{};
-    for (const auto& indicesPerSegment : indices)
-    {
-        nonOfdmaBand.indices.emplace_back(indicesPerSegment);
-        nonOfdmaBand.frequencies.emplace_back(
-            m_wifiPhy->ConvertIndicesToFrequencies(indicesPerSegment));
-    }
-    return nonOfdmaBand;
-}
-
 MHz_u
-HePhy::GetNonOfdmaWidth(HeRu::RuSpec ru) const
+HePhy::GetNonOfdmaWidth(WifiRu::RuSpec ru) const
 {
-    if (ru.GetRuType() == HeRu::RU_26_TONE && ru.GetIndex() == 19)
+    const auto ruType = WifiRu::GetRuType(ru);
+    if (ruType == RuType::RU_26_TONE && WifiRu::GetIndex(ru) == 19)
     {
         // the center 26-tone RU in an 80 MHz channel is not fully covered by
         // any 20 MHz channel, but only by an 80 MHz channel
         return MHz_u{80};
     }
-    return std::max(HeRu::GetBandwidth(ru.GetRuType()), MHz_u{20});
+    return std::max(WifiRu::GetBandwidth(ruType), MHz_u{20});
 }
 
 uint64_t
@@ -1217,7 +1191,7 @@
          * aCCATime after the signal starts and shall continue to indicate the 20 MHz subchannel is
          * busy while the threshold continues to be exceeded.
          */
-        dBm_u ccaThreshold = -62;
+        auto ccaThreshold = m_wifiPhy->GetCcaEdThreshold();
         auto delayUntilCcaEnd = GetDelayUntilCcaEnd(ccaThreshold, band);
 
         if (ppdu)
@@ -1374,7 +1348,7 @@
         {
             // non-HE portion is sent only on the 20 MHz channels covering the RU
             const auto staId = GetStaId(ppdu);
-            const auto ruWidth = HeRu::GetBandwidth(txVector.GetRu(staId).GetRuType());
+            const auto ruWidth = WifiRu::GetBandwidth(WifiRu::GetRuType(txVector.GetRu(staId)));
             channelWidth = (ruWidth < MHz_u{20}) ? MHz_u{20} : ruWidth;
             return WifiSpectrumValueHelper::CreateDuplicated20MhzTxPowerSpectralDensity(
                 GetCenterFrequenciesForNonHePart(ppdu, staId),
@@ -1447,19 +1421,20 @@
     auto centerFrequencies = ppdu->GetTxCenterFreqs();
     const auto currentWidth = txVector.GetChannelWidth();
 
-    HeRu::RuSpec ru = txVector.GetRu(staId);
+    auto ru = txVector.GetRu(staId);
     const auto nonOfdmaWidth = GetNonOfdmaWidth(ru);
     if (nonOfdmaWidth != currentWidth)
     {
         // Obtain the index of the non-OFDMA portion
-        HeRu::RuSpec nonOfdmaRu =
-            HeRu::FindOverlappingRu(currentWidth, ru, HeRu::GetRuType(nonOfdmaWidth));
+        const auto nonOfdmaRu =
+            WifiRu::FindOverlappingRu(currentWidth, ru, WifiRu::GetRuType(nonOfdmaWidth));
 
         const MHz_u startingFrequency = centerFrequencies.front() - (currentWidth / 2);
         centerFrequencies.front() =
             startingFrequency +
             nonOfdmaWidth *
-                (nonOfdmaRu.GetPhyIndex(
+                (WifiRu::GetPhyIndex(
+                     nonOfdmaRu,
                      currentWidth,
                      m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(MHz_u{20})) -
                  1) +
@@ -1682,7 +1657,7 @@
     auto bw = txVector.GetChannelWidth();
     if (txVector.IsMu())
     {
-        bw = HeRu::GetBandwidth(txVector.GetRu(staId).GetRuType());
+        bw = WifiRu::GetBandwidth(WifiRu::GetRuType(txVector.GetRu(staId)));
     }
     return HePhy::GetPhyRate(txVector.GetMode(staId).GetMcsValue(),
                              bw,
@@ -1696,7 +1671,7 @@
     auto bw = txVector.GetChannelWidth();
     if (txVector.IsMu())
     {
-        bw = HeRu::GetBandwidth(txVector.GetRu(staId).GetRuType());
+        bw = WifiRu::GetBandwidth(WifiRu::GetRuType(txVector.GetRu(staId)));
     }
     return HePhy::GetDataRate(txVector.GetMode(staId).GetMcsValue(),
                               bw,
@@ -1729,7 +1704,6 @@
     case 8: // 106-tone RU
         return 102;
     case 20:
-    default:
         return 234;
     case 40:
         return 468;
@@ -1737,6 +1711,9 @@
         return 980;
     case 160:
         return 1960;
+    default:
+        NS_ASSERT_MSG(false, "Invalid channel width: " << channelWidth);
+        return 234;
     }
 }
 
@@ -1849,70 +1826,51 @@
 }
 
 std::vector<WifiSpectrumBandIndices>
-HePhy::ConvertHeRuSubcarriers(MHz_u bandWidth,
-                              MHz_u guardBandwidth,
-                              const std::vector<MHz_u>& centerFrequencies,
-                              MHz_u totalWidth,
-                              Hz_u subcarrierSpacing,
-                              HeRu::SubcarrierRange subcarrierRange,
-                              uint8_t bandIndex)
-{
-    NS_ASSERT_MSG(bandWidth <= totalWidth,
-                  "Bandwidth (" << bandWidth << ") cannot exceed total operating channel width ("
-                                << totalWidth << ")");
+HePhy::ConvertRuSubcarriers(const RuSubcarriersInfo& info)
+{
+    NS_ASSERT_MSG(info.bandWidth <= info.totalWidth,
+                  "Bandwidth (" << info.bandWidth
+                                << ") cannot exceed total operating channel width ("
+                                << info.totalWidth << ")");
     std::vector<WifiSpectrumBandIndices> convertedSubcarriers{};
-    guardBandwidth /= centerFrequencies.size();
+    const auto guardBandwidth{info.guardBandwidth / info.centerFrequencies.size()};
     const auto nGuardBands =
-        static_cast<uint32_t>(((2 * MHzToHz(guardBandwidth)) / subcarrierSpacing) + 0.5);
-    if (bandWidth > (totalWidth / centerFrequencies.size()))
-    {
-        NS_ASSERT(bandIndex == 0);
-        bandWidth /= centerFrequencies.size();
-    }
-    uint32_t centerFrequencyIndex = 0;
-    switch (static_cast<uint16_t>(bandWidth))
-    {
-    case 20:
-        centerFrequencyIndex = (nGuardBands / 2) + 6 + 122;
-        break;
-    case 40:
-        centerFrequencyIndex = (nGuardBands / 2) + 12 + 244;
-        break;
-    case 80:
-        centerFrequencyIndex = (nGuardBands / 2) + 12 + 500;
-        break;
-    case 160:
-        centerFrequencyIndex = (nGuardBands / 2) + 12 + 1012;
-        break;
-    default:
-        NS_FATAL_ERROR("ChannelWidth " << bandWidth << " unsupported");
-        break;
-    }
-
-    const auto numBandsInBand = static_cast<size_t>(MHzToHz(bandWidth) / subcarrierSpacing);
-    centerFrequencyIndex += numBandsInBand * bandIndex;
+        static_cast<uint32_t>(((2 * MHzToHz(guardBandwidth)) / info.subcarrierSpacing) + 0.5);
+    auto bw{info.bandWidth};
+    if (bw > (info.totalWidth / info.centerFrequencies.size()))
+    {
+        NS_ASSERT(info.bandIndex == 0);
+        bw /= info.centerFrequencies.size();
+    }
+    // Figures 27-5 to 27-7 of IEEE 802.11ax-2021: the number of guard subcarriers is 6 for 20 MHz
+    // MHz HE PPDUs and 12 for 40/80/160 MHz HE PPDUs
+    const uint32_t guardSubcarriers = (bw < MHz_u{40}) ? 6 : 12;
+    const auto refRu = WifiRu::GetRuType(bw);
+    const auto offset = WifiRu::GetSubcarrierGroup(bw, refRu, 1, info.mc).back().second;
+    uint32_t centerFrequencyIndex = (nGuardBands / 2) + guardSubcarriers + offset;
+    const auto numBandsInBand = static_cast<size_t>(MHzToHz(bw) / info.subcarrierSpacing);
+    centerFrequencyIndex += numBandsInBand * info.bandIndex;
     // start and stop subcarriers might be in different frequency segments, hence define a low and a
     // high center frequency
     auto centerFrequencyIndexLow = centerFrequencyIndex;
     auto centerFrequencyIndexHigh = centerFrequencyIndex;
-    if (centerFrequencies.size() > 1)
+    if (info.centerFrequencies.size() > 1)
     {
         const auto numBandsBetweenSegments =
-            SpectrumWifiPhy::GetNumBandsBetweenSegments(centerFrequencies,
-                                                        totalWidth,
-                                                        subcarrierSpacing);
-        if (subcarrierRange.first > 0)
+            SpectrumWifiPhy::GetNumBandsBetweenSegments(info.centerFrequencies,
+                                                        info.totalWidth,
+                                                        info.subcarrierSpacing);
+        if (info.subcarrierRange.first > 0)
         {
             centerFrequencyIndexLow += numBandsBetweenSegments;
         }
-        if (subcarrierRange.second > 0)
+        if (info.subcarrierRange.second > 0)
         {
             centerFrequencyIndexHigh += numBandsBetweenSegments;
         }
     }
-    convertedSubcarriers.emplace_back(centerFrequencyIndexLow + subcarrierRange.first,
-                                      centerFrequencyIndexHigh + subcarrierRange.second);
-    ++bandIndex;
+    convertedSubcarriers.emplace_back(centerFrequencyIndexLow + info.subcarrierRange.first,
+                                      centerFrequencyIndexHigh + info.subcarrierRange.second);
     return convertedSubcarriers;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/he/he-phy.h ns-3.45/src/wifi/model/he/he-phy.h
--- ns-3.44/src/wifi/model/he/he-phy.h	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/he/he-phy.h	2025-06-01 20:34:45.617702200 -0700
@@ -174,21 +174,12 @@
      */
     WifiSpectrumBandInfo GetRuBandForRx(const WifiTxVector& txVector, uint16_t staId) const;
     /**
-     * Get the band used to transmit the non-OFDMA part of an HE TB PPDU.
-     *
-     * @param txVector the TXVECTOR used for the transmission
-     * @param staId the STA-ID of the station taking part of the UL MU
-     *
-     * @return the spectrum band used to transmit the non-OFDMA part of an HE TB PPDU
-     */
-    WifiSpectrumBandInfo GetNonOfdmaBand(const WifiTxVector& txVector, uint16_t staId) const;
-    /**
      * Get the width of the non-OFDMA portion of an HE TB PPDU
      *
      * @param ru the RU in which the HE TB PPDU is sent
      * @return the width of the non-OFDMA portion of an HE TB PPDU
      */
-    MHz_u GetNonOfdmaWidth(HeRu::RuSpec ru) const;
+    MHz_u GetNonOfdmaWidth(WifiRu::RuSpec ru) const;
 
     /**
      * @return the UID of the HE TB PPDU being received
@@ -436,29 +427,30 @@
      */
     static Time GetSymbolDuration(Time guardInterval);
 
-    /**
-     * @param bandWidth the width of the band used for the OFDMA transmission. Must be a multiple of
-     * 20 MHz
-     * @param guardBandwidth width of the guard band
-     * @param centerFrequencies the center frequency of each segment
-     * @param totalWidth the width of the operating channel
-     * @param subcarrierSpacing the subcarrier spacing
-     * @param subcarrierRange the subcarrier range of the HE RU
-     * @param bandIndex the index (starting at 0) of the band within the operating channel
-     * @return the converted subcarriers
-     *
-     * This is a helper function to convert HE RU subcarriers, which are relative to the center
-     * frequency subcarrier, to the indexes used by the Spectrum model. The size of the returned
-     * vector corresponds to the number of segments covered by the HE RU.
-     */
-    static std::vector<WifiSpectrumBandIndices> ConvertHeRuSubcarriers(
-        MHz_u bandWidth,
-        MHz_u guardBandwidth,
-        const std::vector<MHz_u>& centerFrequencies,
-        MHz_u totalWidth,
-        Hz_u subcarrierSpacing,
-        HeRu::SubcarrierRange subcarrierRange,
-        uint8_t bandIndex = 0);
+    /// structure containing the information about the RU subcarriers to be able to converted to the
+    /// indices used by the Spectrum model
+    struct RuSubcarriersInfo
+    {
+        MHz_u bandWidth; ///< width of the band used for the OFDMA transmission. Must be a multiple
+                         ///< of 20 MHz
+        MHz_u guardBandwidth;                        ///< width of the guard band
+        const std::vector<MHz_u>& centerFrequencies; ///< center frequency of each segment
+        MHz_u totalWidth;                            ///< width of the operating channel
+        Hz_u subcarrierSpacing;                      ///< subcarrier spacing
+        WifiModulationClass mc;                      ///< modulation class used for the transmission
+        SubcarrierRange subcarrierRange;             ///< subcarrier range of the RU
+        uint8_t bandIndex{0}; ///< index (starting at 0) of the band within the operating channel
+    };
+
+    /**
+     * This is a helper function to convert RU subcarriers, which are relative to the center
+     * frequency subcarrier, to the indices used by the Spectrum model. The size of the returned
+     * vector corresponds to the number of segments covered by the RU.
+     *
+     * @param info the information about the RU subcarrier to convert
+     * @return the indices used by the Spectrum model for the provided RU subcarrier
+     */
+    static std::vector<WifiSpectrumBandIndices> ConvertRuSubcarriers(const RuSubcarriersInfo& info);
 
   protected:
     PhyFieldRxStatus ProcessSig(Ptr<Event> event,
@@ -549,6 +541,18 @@
      */
     static uint16_t GetUsableSubcarriers(MHz_u channelWidth);
 
+    /**
+     * Compute the per-20 MHz CCA durations vector that indicates
+     * for how long each 20 MHz subchannel (corresponding to the
+     * index of the element in the vector) is busy and where a zero duration
+     * indicates that the subchannel is idle. The vector is non-empty if the
+     * operational channel width is larger than 20 MHz.
+     *
+     * @param ppdu the incoming PPDU or nullptr for any signal
+     * @return the per-20 MHz CCA durations vector
+     */
+    virtual std::vector<Time> GetPer20MHzDurations(const Ptr<const WifiPpdu> ppdu);
+
     uint64_t m_previouslyTxPpduUid; //!< UID of the previously sent PPDU, used by AP to recognize
                                     //!< response HE TB PPDUs
     uint64_t m_currentMuPpduUid;    //!< UID of the HE MU or HE TB PPDU being received
@@ -605,18 +609,6 @@
                        const std::vector<Time>& per20MHzDurations);
 
     /**
-     * Compute the per-20 MHz CCA durations vector that indicates
-     * for how long each 20 MHz subchannel (corresponding to the
-     * index of the element in the vector) is busy and where a zero duration
-     * indicates that the subchannel is idle. The vector is non-empty if the
-     * operational channel width is larger than 20 MHz.
-     *
-     * @param ppdu the incoming PPDU or nullptr for any signal
-     * @return the per-20 MHz CCA durations vector
-     */
-    std::vector<Time> GetPer20MHzDurations(const Ptr<const WifiPpdu> ppdu);
-
-    /**
      * Given a PPDU duration value, the TXVECTOR used to transmit the PPDU and
      * the PHY band, compute a valid PPDU duration considering the number and
      * duration of symbols, the preamble duration and the guard interval.
@@ -635,7 +627,7 @@
     std::size_t m_rxHeTbPpdus;                 //!< Number of successfully received HE TB PPDUS
     Ptr<ObssPdAlgorithm> m_obssPdAlgorithm;    //!< OBSS-PD algorithm
     std::vector<Time> m_lastPer20MHzDurations; //!< Hold the last per-20 MHz CCA durations vector
-};                                             // class HePhy
+};
 
 } // namespace ns3
 
